/*
	 2005, e dot studios
	
	License:
	YOU MAY USE THIS PROGRAM AT YOUR OWN RISK. WE ("E DOT STUDIOS") CANNOT BE HELD 	RESPONSIBLE FOR ANY DAMAGE THAT WAS CAUSED TO YOUR COMPUTER. THIS PRODUCT MAY NOT BE SOLD NOR MAY IT BE PLACED ON ANY REMOVABLE MEDIA WITHOUT FIRST CONTACTING THE AUTHOR. YOU ARE ALLOWED TO MAKE 1 (ONE) COPY FOR BACK UP PURPOSES, INTERNET BACK UP OR UPLOADING THIS PRODUCT TO AN INTERNET DRIVE OR SERVER IS PROHIBITED.
	
	The source code is provided as is. You are not allowed to modify or reuse the code without first contacting the author. This is also true for any plugins that are used.
	
	Contact: contact@edot-studios.com
*/

var gNumberOfImages;
var gCurrentImageIndex;
var gCurrentAlbum;
var gImage;

var gImageMaxHeight = 147;
var gImageMaxWidth = 196;

var gDoneButton;
var gDonateButton;
var gInfoButton;
var gAlbumsBuilt;
var gSavedImageLoaded;

var gBackWidth = 216;
var gBackHeight = 200;
var gOldWidth;
var gOldHeight;

function init() {
	if (window.widget) {
		widget.onshow = onshow;
  		widget.onhide = onhide;
  		widget.onremove = onremove;
  		
  		gDoneButton = new AppleGlassButton(document.getElementById("doneButton"), "Done", hideBack);
  		gDonateButton = new AppleGlassButton(document.getElementById("donateButton"), "Donate", gotoDonationPage);


    	gInfoButton = new AppleInfoButton(document.getElementById("infoButton"), document.getElementById("front"), "white", "white", showBack);
		gInfoButton.setStyle('black', 'black');
	
		gImage = new Image();
		
		gAlbumsBuilt = false;
		gSavedImageLoaded = false;
		
		var frontDiv = document.getElementById("front");
		var wHeight = widget.preferenceForKey("widgetHeight");
		var wWidth = widget.preferenceForKey("widgetWidth");
		
		if (wHeight != undefined && wWidth != undefined) {
			updateWindow(wWidth, wHeight);
		}
	
  		onshow();
	}
}

function onshow () {
	loadPrefs();
	loadAlbums(!gAlbumsBuilt);
	
	if (gSavedImageLoaded == false) {
		loadSavedImage();
		gSavedImageLoaded = true;	
	}
}

function onhide () {	
	saveCurrentImage();
}

function onremove() {
	saveCurrentImage();
	saveCurrentSize();
}

function showBack() {
	var front = document.getElementById("front");
    var back = document.getElementById("back");

	/*gOldWidth = window.outerWidth;
	gOldHeight = window.outerHeight;
	updateWindow(gBackWidth, gBackHeight);*/
	
    if (window.widget)
        widget.prepareForTransition("ToBack");

    front.style.display="none";
    back.style.display="block";
	
	loadPrefs();
	
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}

function hideBack() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget)
        widget.prepareForTransition("ToFront");

    back.style.display="none";
    front.style.display="block";

	savePrefs();
		
    if (window.widget)
 		setTimeout ('widget.performTransition();', 0);
	
	//updateWindow(gOldWidth, gOldHeight);       
}

function gotoDonationPage() {
	widget.openURL("http://order.kagi.com/cgi-bin/store.cgi?storeID=33D");
}

function loadAlbums(reset) {
	if (iPhotoLoader) {
		if (reset) {
			var result = iPhotoLoader.buildAlbums();
			
			if (!result) {
				changeImage(-1);
			} else {
				var menuDiv = document.getElementById("popupMenu");
				var totalAlbums = iPhotoLoader.numberOfAlbums();
				
				menuDiv.options.length = 0;
				
				for (var i = 0; i < totalAlbums; i++) {
					var albumName = iPhotoLoader.nameOfAlbumAtIndex(i);
					var imagesCount = iPhotoLoader.numberOfPhotosInAlbum(albumName);
					
					menuDiv.options[i] = new Option(albumName+" ("+imagesCount+")", albumName);
				}
				
				menuDiv.options[0].selected = true;
	
				popupChanged(document.getElementById("popupMenu"));
			}
		} else {
			if (widget.preferenceForKey("randomPic") && iPhotoLoader) {
				gCurrentImageIndex = Math.random()*iPhotoLoader.numberOfPhotosInAlbum(gCurrentAlbum);
				changeImage(gCurrentImageIndex);
			}
		}
	}
	
	gAlbumsBuilt = true;
}

function loadSavedImage() {
  	var albumName = widget.preferenceForKey("albumName");
  	var imgIndex = widget.preferenceForKey("imageIndex");
  		
  	if (albumName != undefined) {
  		var albumIndex = 0;
  		var menuDiv = document.getElementById("popupMenu");
  		
  		for (i = 0; i < menuDiv.options.length; i++) {
  			if (menuDiv.options[i].value == albumName) {
  				albumIndex = i;
  				break;
  			}
  		}
  		
  		menuDiv.options[albumIndex].selected = true;
  		
  		if (iPhotoLoader) {
			gCurrentAlbum = albumName;
			gCurrentImageIndex = imgIndex;
			gNumberOfImages = iPhotoLoader.numberOfPhotosInAlbum(gCurrentAlbum);
			
			changeImage(gCurrentImageIndex);
		}
  			
  	}
}

function saveCurrentImage() {
	widget.setPreferenceForKey(gCurrentAlbum, "albumName");
	widget.setPreferenceForKey(gCurrentImageIndex, "imageIndex");
}

function saveCurrentSize() {	
	widget.setPreferenceForKey(window.outerWidth, "widgetWidth");
	widget.setPreferenceForKey(window.outerHeight, "widgetHeight");
}

function openInApp(appName) {
	if (iPhotoLoader) {
		var normalPath = unescape(gImage.src);
		var path = normalPath.split("://")[1];
		
		iPhotoLoader.openImageAtPathWithApp(path, appName);
	}
}

function popupChanged(el) {
	var selName = el.options[el.selectedIndex].value;
	
	if (iPhotoLoader) {
		gCurrentAlbum = selName;
		gCurrentImageIndex = 0;
		gNumberOfImages = iPhotoLoader.numberOfPhotosInAlbum(gCurrentAlbum);
		
		changeImage(gCurrentImageIndex);
	}
}

function actionPopupChanged(el) {
	var value = el.options[el.selectedIndex].value;
	
	if (value != undefined && value != "") {
		if (value == "custom")
			value = widget.preferenceForKey("customApp");
			
		openInApp(value);
	}
		
	el.options[0].selected = true;
}

function sendToDesktop() {
	if (iPhotoLoader && gImage.src != "") {
		var normalPath = unescape(gImage.src);
		var path = normalPath.split("://")[1];
		iPhotoLoader.sendImageToDesktop(path);
	}
}

function changeImage(index) {
	var photoElement = document.getElementById("photo");
	var imgURL;
	
	if (index < 0) {
		imgURL = "Images/LibNotFound.png";
	} else if (iPhotoLoader) {
    	imgURL = "file://"+escape(iPhotoLoader.imageFromAlbumAtIndex(gCurrentAlbum, index));
    }
        
    photoElement.src = imgURL;
    
    gCurrentImageIndex = index;
    gImage.src = imgURL;
    gImage.onload = imageLoaded;
}

function prevImage() {
	--gCurrentImageIndex;
	
	if (gCurrentImageIndex < 0)
		gCurrentImageIndex = gNumberOfImages-1;
	
	changeImage(gCurrentImageIndex);
}

function nextImage() {
	++gCurrentImageIndex;
	
	if (gCurrentImageIndex > (gNumberOfImages-1))
		gCurrentImageIndex = 0;
	
	changeImage(gCurrentImageIndex);
}

function imageLoaded() {
	var photoDiv = document.getElementById("photo");
	
	var width = gImage.width;
	var height = gImage.height;

	//if (width <= gImageMaxWidth && height <= gImageMaxHeight)
	//	return;

	var img_ar = width/height;

	if (img_ar > gImageMaxWidth/gImageMaxHeight) {
		photoDiv.style.width = gImageMaxWidth+"px";
		photoDiv.style.height = (gImageMaxWidth/img_ar)+"px";
	} else {
		photoDiv.style.width = (gImageMaxHeight*img_ar)+"px";
		photoDiv.style.height = gImageMaxHeight+"px";
	}
	
	/*photoDiv.title = "Dimensions: "+width+"x"+height+"\n";
	photoDiv.title += "Path: "+gImage.src;*/
}

/* PREFERENCES */

function loadPrefs() {
	var libPathDiv = document.getElementById("libPath");
	var randomPicDiv = document.getElementById("randomPic");
	var customAppDiv = document.getElementById("customApp");
	
	if (iPhotoLoader) {
		var path = widget.preferenceForKey("libPath");
		var cApp = widget.preferenceForKey("customApp");
		
		libPathDiv.value = (path == undefined || path == "") ? iPhotoLoader.libraryPath() : path;
		randomPicDiv.checked = widget.preferenceForKey("randomPic");
		customAppDiv.value = (cApp == undefined) ? "" : cApp;
		
		iPhotoLoader.setLibraryPath(libPathDiv.value);
	}
}

function savePrefs() {
	var libPathDiv = document.getElementById("libPath");
	var randomPicDiv = document.getElementById("randomPic");
	var customAppDiv = document.getElementById("customApp");
	
	if (iPhotoLoader) {
		widget.setPreferenceForKey(libPathDiv.value, "libPath");
		widget.setPreferenceForKey(randomPicDiv.checked, "randomPic");
		widget.setPreferenceForKey(customAppDiv.value, "customApp");
		
		if (libPathDiv.value != iPhotoLoader.libraryPath()) {
			iPhotoLoader.setLibraryPath(libPathDiv.value);
			loadAlbums(true);
		} else {
			loadAlbums(false);
		}
	}
}

/* RESIZING */

var growboxInset;

function mouseDown(event) {
	document.addEventListener("mousemove", mouseMove, true);
	document.addEventListener("mouseup", mouseUp, true);

 	growboxInset = {x:(window.innerWidth - event.x), y:(window.innerHeight - event.y)};

    event.stopPropagation();
    event.preventDefault();
}

function mouseMove(event) {
	var x = event.x + growboxInset.x;
    var y = event.y + growboxInset.y;
	
    document.getElementById("resize").style.bottom = 17;
    
	if (y <= 215)
		y = 215;
		
	if (x <= 216)
		x = 216;
		
	updateWindow(x, y);
	
	event.stopPropagation();
    event.preventDefault();
}

function mouseUp(event) {
    document.removeEventListener("mousemove", mouseMove, true);
    document.removeEventListener("mouseup", mouseUp, true);
	
    event.stopPropagation();
    event.preventDefault();
}

function updateWindow(w, h) {
	window.resizeTo(w, h);
		
	var frontDiv = document.getElementById("front");
	frontDiv.style.height = window.outerHeight;
	frontDiv.style.width = window.outerWidth;
		
	var photoDiv = document.getElementById("photo");
	var newHeight = h-38-30;
	var newWidth = w;
	
	var ratio = newWidth/newHeight;
	
	photoDiv.style.height = newHeight;
	photoDiv.style.width = newWidth;
		
	gImageMaxHeight = newHeight;
	gImageMaxWidth = newHeight*ratio;
	
	imageLoaded();
}